diff --git a/hw/core/uboot_image.h b/hw/core/uboot_image.h
index 608022de6e..11b98cdf74 100644
--- a/hw/core/uboot_image.h
+++ b/hw/core/uboot_image.h
@@ -12,7 +12,7 @@
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.     See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License along
@@ -32,127 +32,127 @@
 /*
  * Operating System Codes
  */
-#define IH_OS_INVALID		0	/* Invalid OS	*/
-#define IH_OS_OPENBSD		1	/* OpenBSD	*/
-#define IH_OS_NETBSD		2	/* NetBSD	*/
-#define IH_OS_FREEBSD		3	/* FreeBSD	*/
-#define IH_OS_4_4BSD		4	/* 4.4BSD	*/
-#define IH_OS_LINUX		5	/* Linux	*/
-#define IH_OS_SVR4		6	/* SVR4		*/
-#define IH_OS_ESIX		7	/* Esix		*/
-#define IH_OS_SOLARIS		8	/* Solaris	*/
-#define IH_OS_IRIX		9	/* Irix		*/
-#define IH_OS_SCO		10	/* SCO		*/
-#define IH_OS_DELL		11	/* Dell		*/
-#define IH_OS_NCR		12	/* NCR		*/
-#define IH_OS_LYNXOS		13	/* LynxOS	*/
-#define IH_OS_VXWORKS		14	/* VxWorks	*/
-#define IH_OS_PSOS		15	/* pSOS		*/
-#define IH_OS_QNX		16	/* QNX		*/
-#define IH_OS_U_BOOT		17	/* Firmware	*/
-#define IH_OS_RTEMS		18	/* RTEMS	*/
-#define IH_OS_ARTOS		19	/* ARTOS	*/
-#define IH_OS_UNITY		20	/* Unity OS	*/
+#define IH_OS_INVALID        0    /* Invalid OS    */
+#define IH_OS_OPENBSD        1    /* OpenBSD    */
+#define IH_OS_NETBSD        2    /* NetBSD    */
+#define IH_OS_FREEBSD        3    /* FreeBSD    */
+#define IH_OS_4_4BSD        4    /* 4.4BSD    */
+#define IH_OS_LINUX        5    /* Linux    */
+#define IH_OS_SVR4        6    /* SVR4        */
+#define IH_OS_ESIX        7    /* Esix        */
+#define IH_OS_SOLARIS        8    /* Solaris    */
+#define IH_OS_IRIX        9    /* Irix        */
+#define IH_OS_SCO        10    /* SCO        */
+#define IH_OS_DELL        11    /* Dell        */
+#define IH_OS_NCR        12    /* NCR        */
+#define IH_OS_LYNXOS        13    /* LynxOS    */
+#define IH_OS_VXWORKS        14    /* VxWorks    */
+#define IH_OS_PSOS        15    /* pSOS        */
+#define IH_OS_QNX        16    /* QNX        */
+#define IH_OS_U_BOOT        17    /* Firmware    */
+#define IH_OS_RTEMS        18    /* RTEMS    */
+#define IH_OS_ARTOS        19    /* ARTOS    */
+#define IH_OS_UNITY        20    /* Unity OS    */
 
 /*
  * CPU Architecture Codes (supported by Linux)
  */
-#define IH_CPU_INVALID		0	/* Invalid CPU	*/
-#define IH_CPU_ALPHA		1	/* Alpha	*/
-#define IH_CPU_ARM		2	/* ARM		*/
-#define IH_CPU_I386		3	/* Intel x86	*/
-#define IH_CPU_IA64		4	/* IA64		*/
-#define IH_CPU_MIPS		5	/* MIPS		*/
-#define IH_CPU_MIPS64		6	/* MIPS	 64 Bit */
-#define IH_CPU_PPC		7	/* PowerPC	*/
-#define IH_CPU_S390		8	/* IBM S390	*/
-#define IH_CPU_SH		9	/* SuperH	*/
-#define IH_CPU_SPARC		10	/* Sparc	*/
-#define IH_CPU_SPARC64		11	/* Sparc 64 Bit */
-#define IH_CPU_M68K		12	/* M68K		*/
-#define IH_CPU_NIOS		13	/* Nios-32	*/
-#define IH_CPU_MICROBLAZE	14	/* MicroBlaze   */
-#define IH_CPU_NIOS2		15	/* Nios-II	*/
-#define IH_CPU_BLACKFIN		16	/* Blackfin	*/
-#define IH_CPU_AVR32		17	/* AVR32	*/
+#define IH_CPU_INVALID        0    /* Invalid CPU    */
+#define IH_CPU_ALPHA        1    /* Alpha    */
+#define IH_CPU_ARM        2    /* ARM        */
+#define IH_CPU_I386        3    /* Intel x86    */
+#define IH_CPU_IA64        4    /* IA64        */
+#define IH_CPU_MIPS        5    /* MIPS        */
+#define IH_CPU_MIPS64        6    /* MIPS     64 Bit */
+#define IH_CPU_PPC        7    /* PowerPC    */
+#define IH_CPU_S390        8    /* IBM S390    */
+#define IH_CPU_SH        9    /* SuperH    */
+#define IH_CPU_SPARC        10    /* Sparc    */
+#define IH_CPU_SPARC64        11    /* Sparc 64 Bit */
+#define IH_CPU_M68K        12    /* M68K        */
+#define IH_CPU_NIOS        13    /* Nios-32    */
+#define IH_CPU_MICROBLAZE    14    /* MicroBlaze   */
+#define IH_CPU_NIOS2        15    /* Nios-II    */
+#define IH_CPU_BLACKFIN        16    /* Blackfin    */
+#define IH_CPU_AVR32        17    /* AVR32    */
 
 /*
  * Image Types
  *
  * "Standalone Programs" are directly runnable in the environment
- *	provided by U-Boot; it is expected that (if they behave
- *	well) you can continue to work in U-Boot after return from
- *	the Standalone Program.
+ *    provided by U-Boot; it is expected that (if they behave
+ *    well) you can continue to work in U-Boot after return from
+ *    the Standalone Program.
  * "OS Kernel Images" are usually images of some Embedded OS which
- *	will take over control completely. Usually these programs
- *	will install their own set of exception handlers, device
- *	drivers, set up the MMU, etc. - this means, that you cannot
- *	expect to re-enter U-Boot except by resetting the CPU.
+ *    will take over control completely. Usually these programs
+ *    will install their own set of exception handlers, device
+ *    drivers, set up the MMU, etc. - this means, that you cannot
+ *    expect to re-enter U-Boot except by resetting the CPU.
  * "RAMDisk Images" are more or less just data blocks, and their
- *	parameters (address, size) are passed to an OS kernel that is
- *	being started.
+ *    parameters (address, size) are passed to an OS kernel that is
+ *    being started.
  * "Multi-File Images" contain several images, typically an OS
- *	(Linux) kernel image and one or more data images like
- *	RAMDisks. This construct is useful for instance when you want
- *	to boot over the network using BOOTP etc., where the boot
- *	server provides just a single image file, but you want to get
- *	for instance an OS kernel and a RAMDisk image.
+ *    (Linux) kernel image and one or more data images like
+ *    RAMDisks. This construct is useful for instance when you want
+ *    to boot over the network using BOOTP etc., where the boot
+ *    server provides just a single image file, but you want to get
+ *    for instance an OS kernel and a RAMDisk image.
  *
- *	"Multi-File Images" start with a list of image sizes, each
- *	image size (in bytes) specified by an "uint32_t" in network
- *	byte order. This list is terminated by an "(uint32_t)0".
- *	Immediately after the terminating 0 follow the images, one by
- *	one, all aligned on "uint32_t" boundaries (size rounded up to
- *	a multiple of 4 bytes - except for the last file).
+ *    "Multi-File Images" start with a list of image sizes, each
+ *    image size (in bytes) specified by an "uint32_t" in network
+ *    byte order. This list is terminated by an "(uint32_t)0".
+ *    Immediately after the terminating 0 follow the images, one by
+ *    one, all aligned on "uint32_t" boundaries (size rounded up to
+ *    a multiple of 4 bytes - except for the last file).
  *
  * "Firmware Images" are binary images containing firmware (like
- *	U-Boot or FPGA images) which usually will be programmed to
- *	flash memory.
+ *    U-Boot or FPGA images) which usually will be programmed to
+ *    flash memory.
  *
  * "Script files" are command sequences that will be executed by
- *	U-Boot's command interpreter; this feature is especially
- *	useful when you configure U-Boot to use a real shell (hush)
- *	as command interpreter (=> Shell Scripts).
+ *    U-Boot's command interpreter; this feature is especially
+ *    useful when you configure U-Boot to use a real shell (hush)
+ *    as command interpreter (=> Shell Scripts).
  */
 
-#define IH_TYPE_INVALID		0	/* Invalid Image		*/
-#define IH_TYPE_STANDALONE	1	/* Standalone Program		*/
-#define IH_TYPE_KERNEL		2	/* OS Kernel Image		*/
-#define IH_TYPE_RAMDISK		3	/* RAMDisk Image		*/
-#define IH_TYPE_MULTI		4	/* Multi-File Image		*/
-#define IH_TYPE_FIRMWARE	5	/* Firmware Image		*/
-#define IH_TYPE_SCRIPT		6	/* Script file			*/
-#define IH_TYPE_FILESYSTEM	7	/* Filesystem Image (any type)	*/
-#define IH_TYPE_FLATDT		8	/* Binary Flat Device Tree Blob	*/
-#define IH_TYPE_KERNEL_NOLOAD  14	/* OS Kernel Image (noload)	*/
+#define IH_TYPE_INVALID        0    /* Invalid Image        */
+#define IH_TYPE_STANDALONE    1    /* Standalone Program        */
+#define IH_TYPE_KERNEL        2    /* OS Kernel Image        */
+#define IH_TYPE_RAMDISK        3    /* RAMDisk Image        */
+#define IH_TYPE_MULTI        4    /* Multi-File Image        */
+#define IH_TYPE_FIRMWARE    5    /* Firmware Image        */
+#define IH_TYPE_SCRIPT        6    /* Script file            */
+#define IH_TYPE_FILESYSTEM    7    /* Filesystem Image (any type)    */
+#define IH_TYPE_FLATDT        8    /* Binary Flat Device Tree Blob    */
+#define IH_TYPE_KERNEL_NOLOAD  14    /* OS Kernel Image (noload)    */
 
 /*
  * Compression Types
  */
-#define IH_COMP_NONE		0	/*  No	 Compression Used	*/
-#define IH_COMP_GZIP		1	/* gzip	 Compression Used	*/
-#define IH_COMP_BZIP2		2	/* bzip2 Compression Used	*/
+#define IH_COMP_NONE        0    /*  No     Compression Used    */
+#define IH_COMP_GZIP        1    /* gzip     Compression Used    */
+#define IH_COMP_BZIP2        2    /* bzip2 Compression Used    */
 
-#define IH_MAGIC	0x27051956	/* Image Magic Number		*/
-#define IH_NMLEN		32	/* Image Name Length		*/
+#define IH_MAGIC    0x27051956    /* Image Magic Number        */
+#define IH_NMLEN        32    /* Image Name Length        */
 
 /*
  * all data in network byte order (aka natural aka bigendian)
  */
 
 typedef struct uboot_image_header {
-	uint32_t	ih_magic;	/* Image Header Magic Number	*/
-	uint32_t	ih_hcrc;	/* Image Header CRC Checksum	*/
-	uint32_t	ih_time;	/* Image Creation Timestamp	*/
-	uint32_t	ih_size;	/* Image Data Size		*/
-	uint32_t	ih_load;	/* Data	 Load  Address		*/
-	uint32_t	ih_ep;		/* Entry Point Address		*/
-	uint32_t	ih_dcrc;	/* Image Data CRC Checksum	*/
-	uint8_t		ih_os;		/* Operating System		*/
-	uint8_t		ih_arch;	/* CPU architecture		*/
-	uint8_t		ih_type;	/* Image Type			*/
-	uint8_t		ih_comp;	/* Compression Type		*/
-	uint8_t		ih_name[IH_NMLEN];	/* Image Name		*/
+    uint32_t    ih_magic;    /* Image Header Magic Number    */
+    uint32_t    ih_hcrc;    /* Image Header CRC Checksum    */
+    uint32_t    ih_time;    /* Image Creation Timestamp    */
+    uint32_t    ih_size;    /* Image Data Size        */
+    uint32_t    ih_load;    /* Data     Load  Address        */
+    uint32_t    ih_ep;        /* Entry Point Address        */
+    uint32_t    ih_dcrc;    /* Image Data CRC Checksum    */
+    uint8_t        ih_os;        /* Operating System        */
+    uint8_t        ih_arch;    /* CPU architecture        */
+    uint8_t        ih_type;    /* Image Type            */
+    uint8_t        ih_comp;    /* Compression Type        */
+    uint8_t        ih_name[IH_NMLEN];    /* Image Name        */
 } uboot_image_header_t;
 
 
diff --git a/hw/ppc/ppc440_bamboo.c b/hw/ppc/ppc440_bamboo.c
index 7fb620b9a0..06db2a118a 100644
--- a/hw/ppc/ppc440_bamboo.c
+++ b/hw/ppc/ppc440_bamboo.c
@@ -3,9 +3,9 @@
  *
  * Copyright 2007 IBM Corporation.
  * Authors:
- *	Jerone Young <jyoung5@us.ibm.com>
- *	Christian Ehrhardt <ehrhardt@linux.vnet.ibm.com>
- *	Hollis Blanchard <hollisb@us.ibm.com>
+ *    Jerone Young <jyoung5@us.ibm.com>
+ *    Christian Ehrhardt <ehrhardt@linux.vnet.ibm.com>
+ *    Hollis Blanchard <hollisb@us.ibm.com>
  *
  * This work is licensed under the GNU GPL license version 2 or later.
  *
diff --git a/hw/ppc/spapr.c b/hw/ppc/spapr.c
index 4dd90b75cc..b74b0e6713 100644
--- a/hw/ppc/spapr.c
+++ b/hw/ppc/spapr.c
@@ -921,7 +921,7 @@ static void spapr_dt_rtas(SpaprMachineState *spapr, void *fdt)
      * is off-by-one.
      */
     _FDT(fdt_setprop_cell(fdt, rtas, "rtas-size", RTAS_ERROR_LOG_MAX +
-			  ms->smp.max_cpus * sizeof(uint64_t)*2 + sizeof(uint64_t)));
+              ms->smp.max_cpus * sizeof(uint64_t)*2 + sizeof(uint64_t)));
     _FDT(fdt_setprop_cell(fdt, rtas, "rtas-error-log-max",
                           RTAS_ERROR_LOG_MAX));
     _FDT(fdt_setprop_cell(fdt, rtas, "rtas-event-scan-rate",
diff --git a/hw/ppc/spapr_rtas.c b/hw/ppc/spapr_rtas.c
index b476382ae6..1ca41a5c7a 100644
--- a/hw/ppc/spapr_rtas.c
+++ b/hw/ppc/spapr_rtas.c
@@ -475,16 +475,16 @@ static void rtas_ibm_nmi_interlock(PowerPCCPU *cpu,
 
     if (spapr->fwnmi_machine_check_interlock != cpu->vcpu_id) {
         /*
-	 * The vCPU that hit the NMI should invoke "ibm,nmi-interlock"
+     * The vCPU that hit the NMI should invoke "ibm,nmi-interlock"
          * This should be PARAM_ERROR, but Linux calls "ibm,nmi-interlock"
-	 * for system reset interrupts, despite them not being interlocked.
-	 * PowerVM silently ignores this and returns success here. Returning
-	 * failure causes Linux to print the error "FWNMI: nmi-interlock
-	 * failed: -3", although no other apparent ill effects, this is a
-	 * regression for the user when enabling FWNMI. So for now, match
-	 * PowerVM. When most Linux clients are fixed, this could be
-	 * changed.
-	 */
+     * for system reset interrupts, despite them not being interlocked.
+     * PowerVM silently ignores this and returns success here. Returning
+     * failure causes Linux to print the error "FWNMI: nmi-interlock
+     * failed: -3", although no other apparent ill effects, this is a
+     * regression for the user when enabling FWNMI. So for now, match
+     * PowerVM. When most Linux clients are fixed, this could be
+     * changed.
+     */
         rtas_st(rets, 0, RTAS_OUT_SUCCESS);
         return;
     }
diff --git a/include/hw/ppc/ppc.h b/include/hw/ppc/ppc.h
index 93e614cffd..f3fe9b0f6a 100644
--- a/include/hw/ppc/ppc.h
+++ b/include/hw/ppc/ppc.h
@@ -95,11 +95,11 @@ enum {
     ARCH_MAC99_U3,
 };
 
-#define FW_CFG_PPC_WIDTH	(FW_CFG_ARCH_LOCAL + 0x00)
-#define FW_CFG_PPC_HEIGHT	(FW_CFG_ARCH_LOCAL + 0x01)
-#define FW_CFG_PPC_DEPTH	(FW_CFG_ARCH_LOCAL + 0x02)
-#define FW_CFG_PPC_TBFREQ	(FW_CFG_ARCH_LOCAL + 0x03)
-#define FW_CFG_PPC_CLOCKFREQ	(FW_CFG_ARCH_LOCAL + 0x04)
+#define FW_CFG_PPC_WIDTH    (FW_CFG_ARCH_LOCAL + 0x00)
+#define FW_CFG_PPC_HEIGHT    (FW_CFG_ARCH_LOCAL + 0x01)
+#define FW_CFG_PPC_DEPTH    (FW_CFG_ARCH_LOCAL + 0x02)
+#define FW_CFG_PPC_TBFREQ    (FW_CFG_ARCH_LOCAL + 0x03)
+#define FW_CFG_PPC_CLOCKFREQ    (FW_CFG_ARCH_LOCAL + 0x04)
 #define FW_CFG_PPC_IS_KVM       (FW_CFG_ARCH_LOCAL + 0x05)
 #define FW_CFG_PPC_KVM_HC       (FW_CFG_ARCH_LOCAL + 0x06)
 #define FW_CFG_PPC_KVM_PID      (FW_CFG_ARCH_LOCAL + 0x07)